Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# StreamHandler Class Reference

`#include <StreamHandler.h>`

List of all members.

## Public Member Functions
| StreamHandler ()
void | startRegistration (const char *name, bool registerWithExternalOperator)
void | registerBase ()
void | finishRegistration ()
template<class T> void | registerWithSpecification (const char *name, T &t)
template<class T> void | registerDynamicArrayWithSpecification (const char *name, T &t)
template<class T> void | registerEnumWithSpecification (const char *name, const T &t, T numberOfEnumElements, const char *(*fp)(T))
template<class T> void | registerEnum (const T &t, T numberOfEnumElements, const char *(*fp)(T))
## Public Attributes
bool | registering
bool | registeringBase
## Private Attributes
hash_map< const char *, const char * > | basicTypeSpecification
hash_map< const char *, std::vector< std::pair< std::string, const char * > > > | specification
hash_map< const char *, std::vector< const char * > > | enumSpecification
std::stack< std::pair< hash_map< const char *, std::vector< std::pair< std::string, const char * > > >::iterator, RegisteringAttributes > > | currentRegisteringEntryStack
## Friends
Out & | operator<< (Out &, const StreamHandler &)

## Constructor & Destructor Documentation

StreamHandler::StreamHandler | ( |  | ) | `[inline]`

| Definition at line 205 of file StreamHandler.h. References basicTypeSpecification, and registeringBase.

## Member Function Documentation

void StreamHandler::startRegistration | ( | const char * | name,
|  | bool | registerWithExternalOperator
| ) |

| Definition at line 8 of file StreamHandler.cpp. References RegisteringAttributes::baseClass, currentRegisteringEntryStack, RegisteringAttributes::externalOperator, RegisteringAttributes::registering, registeringBase, and specification.

void StreamHandler::registerBase | ( |  | ) | `[inline]`

| Definition at line 219 of file StreamHandler.h. References registeringBase. Referenced by SeenBallState::serialize().

void StreamHandler::finishRegistration | ( |  | ) | `[inline]`

| Definition at line 220 of file StreamHandler.h. References currentRegisteringEntryStack, and registeringBase.

template<class T>
void StreamHandler::registerWithSpecification | ( | const char * | name,
|  | T & | t
| ) | `[inline]`

| Definition at line 237 of file StreamHandler.h. References currentRegisteringEntryStack.

template<class T>
void StreamHandler::registerDynamicArrayWithSpecification | ( | const char * | name,
|  | T & | t
| ) | `[inline]`

| Definition at line 257 of file StreamHandler.h. References currentRegisteringEntryStack.

template<class T>
void StreamHandler::registerEnumWithSpecification | ( | const char * | name,
|  | const T & | t,
|  | T | numberOfEnumElements,
|  | const char *(* | fp)(T)
| ) | `[inline]`

| Definition at line 277 of file StreamHandler.h. References currentRegisteringEntryStack, and enumSpecification.

template<class T>
void StreamHandler::registerEnum | ( | const T & | t,
|  | T | numberOfEnumElements,
|  | const char *(* | fp)(T)
| ) | `[inline]`

| Definition at line 310 of file StreamHandler.h. References enumSpecification.

## Friends And Related Function Documentation

Out& operator<< | ( | Out & | ,
|  | const StreamHandler & |
| ) | `[friend]`

| Definition at line 43 of file StreamHandler.cpp.

## Member Data Documentation

hash_map<const char*,const char*> StreamHandler::basicTypeSpecification`[private]`

| Definition at line 195 of file StreamHandler.h. Referenced by operator<<(), and StreamHandler().

hash_map<const char*, std::vector<std::pair< std::string, const char*> > > StreamHandler::specification`[private]`

| Definition at line 196 of file StreamHandler.h. Referenced by operator<<(), and startRegistration().

hash_map<const char*, std::vector<const char*> > StreamHandler::enumSpecification`[private]`

| Definition at line 198 of file StreamHandler.h. Referenced by operator<<(), registerEnum(), and registerEnumWithSpecification().

std::stack< std::pair< hash_map<const char*, std::vector<std::pair< std::string, const char*> > >::iterator, RegisteringAttributes> > StreamHandler::currentRegisteringEntryStack`[private]`

| Definition at line 200 of file StreamHandler.h. Referenced by finishRegistration(), registerDynamicArrayWithSpecification(), registerEnumWithSpecification(), registerWithSpecification(), and startRegistration().

bool StreamHandler::registering

| Definition at line 203 of file StreamHandler.h.

bool StreamHandler::registeringBase

| Definition at line 204 of file StreamHandler.h. Referenced by finishRegistration(), registerBase(), startRegistration(), and StreamHandler().

The documentation for this class was generated from the following files:

- Tools/Streams/StreamHandler.h
- Tools/Streams/StreamHandler.cpp